CKEDITOR.dialog.add('semwidgTemplateDialog', function (editor) {

	var dialog = {};

	dialog.title = 'SemwidgJS Template';

	dialog.minWidth = 800;
	dialog.minHeight = 400;

	dialog.contents = [];

	var templateTab = {};
	templateTab.id = 'templateProperties';
	templateTab.label = 'Template Properties';

	templateTab.elements = [
		{
			type: 'html',
			id: 'templateTabHtmlInfo',
			html: '<div><h1 id="semwidgckTemplateTabTitle">Enter Template Properties:</h1></div>'
		},
		{
			type: 'html',
			id: 'templateTabHtmlForm',
			html: '<div id="semwidgckTemplateTab"></div>',
			setup: function(widget) {
				CKEDITOR.SemwidgJS.SemwidgTemplateDialog.setupTemplateTab(widget);
			},
			commit: function(widget) {
				CKEDITOR.SemwidgJS.SemwidgTemplateDialog.commitTemplateTab(widget);
			}
		}
	];

	dialog.contents.push(templateTab);

	var templateModificationTab = {};
	templateModificationTab.id = 'templateModifications';
	templateModificationTab.label = 'Template Modifications'

	templateModificationTab.elements = [
		{
			type: 'html',
			id: 'templateModificationTabHtmlInfo',
			html: '<div><h1 id="semwidgcktemplateModificationTabTitle">Perform Template Modifications:</h1></div>'
		},
		{
			type: 'html',
			id: 'templateModificationTabHtmlForm',
			html: '<div id="semwidgckTemplateModificationTab"></div>',
			setup: function(widget) {
				CKEDITOR.SemwidgJS.SemwidgTemplateDialog.setupTemplateModificationTab(widget);
			},
			commit: function(widget) {
				CKEDITOR.SemwidgJS.SemwidgTemplateDialog.commitTemplateModificationTab(widget);
			}
		}
	];

	dialog.contents.push(templateModificationTab);

	dialog.onShow = function() {
		if (CKEDITOR.SemwidgJS.data.configType == 'template_definition' /* TODO validate */) {
			CKEDITOR.SemwidgJS.SemwidgTemplateDialog.buildTemplateDialog(this, editor);

			// CKEDITOR.SemwidgJS.setDefaultConfigData(this.configType);
		}
	};

	dialog.onOk = function() {
		this.semwidgClosingType = 'ok';
	};

	dialog.onCancel = function() {
		this.semwidgClosingType = 'cancel';
	};

	dialog.onHide = function() {
		if (this.semwidgClosingType == 'ok') {
			editor.setMode('source');
			editor.setMode('wysiwyg');
		}
	}

	return dialog;
});

CKEDITOR.SemwidgJS.SemwidgTemplateDialog = function() {

};

CKEDITOR.SemwidgJS.SemwidgTemplateDialog.buildTemplateDialog = function(dialog, editor) {

	// build Template Tab

	var editButton = '<span>';
		editButton += '<a id="semwidgckTemplateProperty_button_edit" class="cke_dialog_ui_button" ';
				editButton += 'role="button" hidefocus="true" href="javascript:void(0)" ';
				editButton += 'style="width: 60px; margin: 0 1px;">';
			editButton += '<span class="cke_dialog_ui_button">Edit</span>';
		editButton += '</a>';
	editButton += '</span>';

	var addButton = '<span>';
		addButton += '<a id="semwidgckTemplateProperty_button_add" class="cke_dialog_ui_button" ';
				addButton += 'role="button" hidefocus="true" href="javascript:void(0)" ';
				addButton += 'style="width: 60px; margin: 0 1px;">';
			addButton += '<span class="cke_dialog_ui_button">Add</span>';
		addButton += '</a>';
	addButton += '</span>';

	var deleteButton = '<span>';
		deleteButton += '<a id="semwidgckTemplateProperty_button_delete" class="cke_dialog_ui_button" ';
				deleteButton += 'role="button" hidefocus="true" href="javascript:void(0)" ';
				deleteButton += 'style="width: 60px; margin: 0 1px;">';
			deleteButton += '<span class="cke_dialog_ui_button">Delete</span>';
		deleteButton += '</a>';
	deleteButton += '</span>';

	var templateTab = $('#semwidgckTemplateTab');

	var templateTabHtml = '';
	templateTabHtml += '<table style="width: 100%;">';
		templateTabHtml += '<tr>';
			templateTabHtml += '<td style="padding: 4px 0;">Id:</td>';
			templateTabHtml += '<td style="padding: 4px 0px 4px 8px; width: 100%;"><input ';
			templateTabHtml += 'id="semwidgckTemplateProperty_input_id" ';
			templateTabHtml += 'class="cke_dialog_ui_input_text" ';
		templateTabHtml += '></td>';
		templateTabHtml += '</tr>';
		templateTabHtml += '<tr>';
			templateTabHtml += '<td style="padding: 8px 0; vertical-align: top">Parameters:</td>';
			templateTabHtml += '<td style="padding: 4px 0px 4px 8px; width: 100%;">';
				templateTabHtml += '<select name="parameters" size="6" ';
				templateTabHtml += 'id="semwidgckTemplateProperty_select_parameters" ';
				templateTabHtml += 'class="cke_dialog_ui_input_select" ';
				templateTabHtml += 'style="width: 100%; height: unset; display: block; margin-bottom: 4px;"></select>';
				templateTabHtml += '<input id="semwidgckTemplateProperty_input_parameter" ';
				templateTabHtml += 'class="cke_dialog_ui_input_text" ';
				templateTabHtml += 'style="margin-right: 2px; width: calc(100% - 192px);" >';

				templateTabHtml += editButton;
				templateTabHtml += addButton;
				templateTabHtml += deleteButton;

			templateTabHtml += '</td>';
		templateTabHtml += '</tr>';
	templateTabHtml += '</table>';

	templateTab.html(templateTabHtml);

	$('#semwidgckTemplateProperty_select_parameters').on('change', function(e) {
		var option = $(e.target).find('option:selected');
		$('#semwidgckTemplateProperty_input_parameter').val(option.val());
	});

	$('#semwidgckTemplateProperty_button_edit').on('click', function() {
		var val = $('#semwidgckTemplateProperty_input_parameter').val();
		var options = $('#semwidgckTemplateProperty_select_parameters').find('option');
		var option = $('#semwidgckTemplateProperty_select_parameters').find('option:selected');

		if (option.length <= 0) {
			return
		}

		var unique = true;
		for (var i = 0; i < options.length; i++) {
			if (val == options[i].text) {
				unique = false;
				break;
			}
		}

		if (unique) {
			option.text(val);
		}
		
	});

	$('#semwidgckTemplateProperty_button_add').on('click', function() {
		var val = $('#semwidgckTemplateProperty_input_parameter').val();
		var options = $('#semwidgckTemplateProperty_select_parameters').find('option');

		var unique = true;
		for (var i = 0; i < options.length; i++) {
			if (val == options[i].text) {
				unique = false;
				break;
			}
		}

		if (unique) {
			$('#semwidgckTemplateProperty_select_parameters').append($('<option>', {
				text: val
			}));
		}
	});

	$('#semwidgckTemplateProperty_button_delete').on('click', function() {
		$('#semwidgckTemplateProperty_select_parameters').find('option:selected').remove();
	});


	// build Template Modification Tab

	var templateModificationTab = $('#semwidgckTemplateModificationTab');

	var templateModificationTabHtml = '<div style="height: 300px; overflow: auto; border-top: 1px solid #ccc; border-bottom: 1px solid #ccc;"><table style="width: 100%;" id="semwidgckTemplateModificationTabTable"></table></div>';

	templateModificationTabHtml += '<div style="margin: 6px 0;">' +
			'<span>Find </span>' +
			'<div style="display: inline-block; width: calc((100% - 120px) / 2 - 2px);"><input id="semwidgckTemplateModification_input_find" class="cke_dialog_ui_input_text" style="font-family: monospace;"></div>' +
			'<span> and replace with </span>' +
			'<div style="display: inline-block; width: calc((100% - 120px) / 2 - 2px);"><input id="semwidgckTemplateModification_input_replace" class="cke_dialog_ui_input_text" style="font-family: monospace;"></div>' +
			'</div>';


	var findButton = '<span>';
		findButton += '<a id="semwidgckTemplateModification_button_find" class="cke_dialog_ui_button" ';
				findButton += 'role="button" hidefocus="true" href="javascript:void(0)" ';
				findButton += 'style="width: 70px; margin: 0 2px;">';
			findButton += '<span class="cke_dialog_ui_button">Find</span>';
		findButton += '</a>';
	findButton += '</span>';

	var replaceButton = '<span>';
		replaceButton += '<a id="semwidgckTemplateModification_button_replace" class="cke_dialog_ui_button" ';
				replaceButton += 'role="button" hidefocus="true" href="javascript:void(0)" ';
				replaceButton += 'style="width: 70px; margin: 0 2px;">';
			replaceButton += '<span class="cke_dialog_ui_button">Replace</span>';
		replaceButton += '</a>';
	replaceButton += '</span>';

	var replaceAllButton = '<span>';
		replaceAllButton += '<a id="semwidgckTemplateModification_button_replace_all" class="cke_dialog_ui_button" ';
				replaceAllButton += 'role="button" hidefocus="true" href="javascript:void(0)" ';
				replaceAllButton += 'style="width: 90px; margin: 0 2px;">';
			replaceAllButton += '<span class="cke_dialog_ui_button">Replace All</span>';
		replaceAllButton += '</a>';
	replaceAllButton += '</span>';

	templateModificationTabHtml += '<div style="text-align: right;">' + findButton + replaceButton + replaceAllButton + '</div>';
	templateModificationTab.html(templateModificationTabHtml);


	// Input Autosuggest

	var findAutosuggestObj = CKEDITOR.SemwidgJS.textInputToAutosuggest('semwidgckTemplateModification_input_find', true);
	findAutosuggestObj.setSelectFunction(function(value) {
		this.element.val(value);
		this.element.focus();
	});

	findAutosuggestObj.setRequestFunction(function(value) {

		var namedResources = editor.getSemwidgJS().getConfig().getResources();
		var namedResourcesArray = [];

		for (var n = 0; n < namedResources.length; n++) {
			namedResourcesArray.push(namedResources[n].id);
		}
		var resultContains = [];
		var resultContainsNot = [];

		if (namedResourcesArray) {
			for (var i = 0; i < namedResourcesArray.length; i++) {
				if (namedResourcesArray[i].indexOf(value) > -1) {
					resultContains.push(namedResourcesArray[i]);
				}else {
					resultContainsNot.push(namedResourcesArray[i]);
				}
			}
		};

		var simpleStringArraySort = function(a, b) {
			var levA = CKEDITOR.SemwidgJS.levenshteinDistance(a, value);
			var levB = CKEDITOR.SemwidgJS.levenshteinDistance(b, value);

			return levA - levB;
		};

		resultContains.sort(simpleStringArraySort);
		resultContainsNot.sort(simpleStringArraySort);

		var result = resultContains.concat(resultContainsNot);

		for (var i = 0; i < result.length; i++) {
			result[i] = ['<span style="font-family: monospace;">' + result[i] + '</span>', result[i]];
		}

		this.setResult(result);
		
	}, 0);

	var replaceAutosuggestObj = CKEDITOR.SemwidgJS.textInputToAutosuggest('semwidgckTemplateModification_input_replace', true);
	replaceAutosuggestObj.setSelectFunction(function(value) {
		this.element.val(value);
		this.element.focus();
	});

	replaceAutosuggestObj.setRequestFunction(function(value) {

		var parameters = $('#semwidgckTemplateProperty_select_parameters').find('option');
		var parametersArray = [];

		for (var n = 0; n < parameters.length; n++) {
			parametersArray.push('%%' + parameters[n].value + '%%');
		}
		var resultContains = [];
		var resultContainsNot = [];

		if (parametersArray) {
			for (var i = 0; i < parametersArray.length; i++) {
				if (parametersArray[i].indexOf(value) > -1) {
					resultContains.push(parametersArray[i]);
				}else {
					resultContainsNot.push(parametersArray[i]);
				}
			}
		};

		var simpleStringArraySort = function(a, b) {
			var levA = CKEDITOR.SemwidgJS.levenshteinDistance(a, value);
			var levB = CKEDITOR.SemwidgJS.levenshteinDistance(b, value);

			return levA - levB;
		};

		resultContains.sort(simpleStringArraySort);
		resultContainsNot.sort(simpleStringArraySort);

		var result = resultContains.concat(resultContainsNot);

		for (var i = 0; i < result.length; i++) {
			result[i] = ['<span style="font-family: monospace;">' + result[i] + '</span>', result[i]];
		}
		
		this.setResult(result);
		
	}, 0);


	// Buttons

	$('#semwidgckTemplateModification_button_find').on('click', function() {
		var find = $('#semwidgckTemplateModification_input_find').val();

		if (!find || find == '') {
			alert('"Find" must not be empty');
			return;
		}
		
		var propertiesArea = $('#semwidgckTemplateModificationTabTable');

		var inputs = propertiesArea.find('input');
		var inputIds = [];

		for (var i = 0; i < inputs.length; i++) {
			inputIds.push(inputs[i].id);
		}

		if (!CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.id || CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.id == '') {
			CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.id = inputIds[0];
		}

		CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelectionId = CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.id;

		var propertyStartIndex = inputIds.indexOf(CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelectionId);
		
		var propertyId;
		var property;
		var propertyVal;
		var searchIndex = -1;

		for (var j = 0; j <= inputIds.length; j++) {

			propertyId = inputIds[(j + propertyStartIndex) % inputIds.length];
			property = $('#' + propertyId);
			propertyVal = property.val();

			if (!propertyVal) {
				continue;
			}

			if (CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.id != propertyId) {
				CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.active = false;
				CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.id = propertyId;
				CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.start = 0;
				CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.end = 0;
			}

			searchIndex = propertyVal.indexOf(find, CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.start);

			if (searchIndex >= 0) {
				CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.active = true;
				CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.id = propertyId;
				CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.start = searchIndex;
				CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.end = searchIndex + find.length;
				break;
			}
		}

		if (CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.active) {
			property.focus();
			property[0].setSelectionRange(CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.start,
					CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.start + find.length);
		}
		
	});

	$('#semwidgckTemplateModification_button_replace').on('click', function() {
		
		if (CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.active) {
			var rep = $('#semwidgckTemplateModification_input_replace').val();
			var elem = $('#' + CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.id);

			if (elem) {
				var oldVal = elem.val();
				var newVal = oldVal.substring(0, CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.start) +
						rep + oldVal.substring(CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.end);
				elem.val(newVal);

				elem.focus();
				elem[0].setSelectionRange(CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.start,
						CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.start + rep.length);
			}else {
				alert('No text has been selected for replacing.');
			}
		}else {
			alert('No text has been selected for replacing.');
		}
		
	});

	$('#semwidgckTemplateModification_button_replace_all').on('click', function() {
		var find = $('#semwidgckTemplateModification_input_find').val();

		if (!find || find == '') {
			alert('"Find" must not be empty');
			return;
		}

		var rep = $('#semwidgckTemplateModification_input_replace').val();
		
		var propertiesArea = $('#semwidgckTemplateModificationTabTable');

		var inputs = propertiesArea.find('input');
		var inputIds = [];

		for (var i = 0; i < inputs.length; i++) {
			inputIds.push(inputs[i].id);
		}

		if (!CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.id || CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.id == '') {
			CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.id = inputIds[0];
		}

		CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelectionId = CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.id;

		var propertyStartIndex = inputIds.indexOf(CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelectionId);
		
		var propertyId;
		var property;
		var propertyVal;
		var searchIndex = -1;
		var counter = 0;

		// var findFunction = function() {
		for (var j = 0; j < inputIds.length; j++) {

			propertyId = inputIds[(j + propertyStartIndex) % inputIds.length];
			property = $('#' + propertyId);
			propertyVal = property.val();

			CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.active = false;
			CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.id = propertyId;
			CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.start = 0;
			CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.end = 0;


			do {
				if (propertyVal) {
					searchIndex = propertyVal.indexOf(find, CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.start);

					if (searchIndex >= 0) {
						CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.active = true;
						CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.id = propertyId;
						CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.start = searchIndex;
						CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.end = searchIndex + find.length;
						
						var newVal = propertyVal.substring(0, CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.start) +
								rep + propertyVal.substring(CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.end);
						property.val(newVal);
						propertyVal = newVal;

						CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.start += rep.length;
						CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.end = CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.start;

						counter++;
					}
				}else {
					searchIndex = -1;
				}
				
			}while(searchIndex >= 0)
			

			
		}

		alert('Replaced ' + counter + ' occurences of "' + find + '"');
	});
};

CKEDITOR.SemwidgJS.SemwidgTemplateDialog.setupTemplateTab = function(widget) {
	var type = widget.element.getAttribute('data-sw-config');

	if(!type) {
		return;
	}

	var id = widget.element.getAttribute('data-swp-id');
	if (id){
		$('#semwidgckTemplateProperty_input_id').val(id);
	}

	var parameters = widget.element.getAttribute('data-swp-parameter');
	if (parameters){
		$('#semwidgckTemplateProperty_select_parameters').html('');

		var list = [];
		list = parameters.split(',');
		for (var i = 0; i < list.length; i++) {
			list[i] = list[i].trim().replace(/[\%]/g, '');

			$('#semwidgckTemplateProperty_select_parameters').append('<option>' + list[i] + '</option>');

		}

	}

};

CKEDITOR.SemwidgJS.SemwidgTemplateDialog.commitTemplateTab = function(widget) {

	var editor = widget.editor;

	// add Id if not set
	if (editor.getSemwidgJS().Util.String.isEmpty($('#semwidgckTemplateProperty_input_id').val())) {
		$('#semwidgckTemplateProperty_input_id').val('Template-' + editor.getSemwidgJS().Util.getUniqueId());
	}

	widget.element.setAttribute('data-swp-id', $('#semwidgckTemplateProperty_input_id').val());

	var parameters = [];
	var options = $('#semwidgckTemplateProperty_select_parameters').find('option');

	for (var i = 0; i < options.length; i++) {
		parameters.push(options[i].text);
	}

	widget.element.setAttribute('data-swp-parameter', parameters.join(', '));
};

CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection = {
	active: false,
	id: null,
	start: 0,
	end: 0
};

CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelectionId = '';

CKEDITOR.SemwidgJS.SemwidgTemplateDialog.setupTemplateModificationTab = function(widget) {

	// var id = widget.element.getAttribute('data-swp-id');

	var editor = widget.editor;
	var element = $(widget.element.$);
	
	var widgets = element.find('*[data-swp-id]');

	var html = '';
	var attribues;
	var i, j = 0;
	var id = null;
	var type = null;
	var label;
	var value;
	var propertyIds = [];

	for (i = 0; i < widgets.length; i++) {
		id = null; type = null;

		attributes = widgets[i].attributes;

		for (j = 0; j < attributes.length; j++) {
			if (attributes[j].name == 'data-swp-id') {
				id = attributes[j].value;
				if (type) {
					break;
				}
			}
			if (attributes[j].name == 'data-sw-widget') {
				type = attributes[j].value;
				if (id) {
					break;
				}
			}
		}

		html += '<tr>';
		html += '<td colspan="2"  style="padding: 8px 0; font-weight: bold;">' + id + ' (' + type + ')</td>';
		
		html += '</tr>';

		for (j = 0; j < attributes.length; j++) {
			if (attributes[j].name != 'data-swp-id' && attributes[j].name.lastIndexOf('data-swp-', 0) == 0) {
				label = editor.getSemwidgJS().Util.String.toUpperCamelCase(attributes[j].name.substring(9));
				
				propertyIds.push('semwidgckWidgetProperty_input_' + editor.getSemwidgJS().Util.String.toCamelCase(id) + '_' + label);

				html += '<tr>';
					html += '<td style="padding: 8px 0; vertical-align: top">' + label + ':</td>';
					html += '<td style="padding: 4px 8px 4px 8px; width: 100%;">' +
								'<input id="' + propertyIds[propertyIds.length - 1] + '" ' +
									'class="cke_dialog_ui_input_text" style="font-family: monospace;" ' +
									'value="' + attributes[j].value + '">';
					html +=  '</td>';
				html += '</tr>';
			}
		}
	}

	$('#semwidgckTemplateModificationTabTable').html(html);

	// selection is lost on button click, so we have to save it here
	var elem;
	for (i = 0; i < propertyIds.length; i++) {
		elem = $('#' + propertyIds[i]);

		elem.on('keypress', function(e){
			CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.active = false;
			CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.id = this.id;
			CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.start = this.selectionStart;
			CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.end = this.selectionEnd;
		});

		elem.on('click', function(e){
			if (this.selectionStart == this.selectionEnd){
				CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.active = false;
				CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.id = this.id;
				CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.start = this.selectionStart;
				CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.end = this.selectionEnd;
			}
		});

		elem.on('select', function(e){
			CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.active = true;
			CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.id = this.id;
			CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.start = this.selectionStart;
			CKEDITOR.SemwidgJS.SemwidgTemplateDialog.textSelection.end = this.selectionEnd;
		});
	}
};

CKEDITOR.SemwidgJS.SemwidgTemplateDialog.commitTemplateModificationTab = function(widget) {

	var editor = widget.editor;
	var element = $(widget.element.$);
	
	var widgets = element.find('*[data-swp-id]');

	var attribues;
	var i, j = 0;
	var id = null;

	var label;
	for (i = 0; i < widgets.length; i++) {
		id = null;

		attributes = widgets[i].attributes;

		for (j = 0; j < attributes.length; j++) {
			if (attributes[j].name == 'data-swp-id') {
				id = attributes[j].value;
				break;
			}
		}

		for (j = 0; j < attributes.length; j++) {
			if (attributes[j].name != 'data-swp-id' && attributes[j].name.lastIndexOf('data-swp-', 0) == 0) {
				label = editor.getSemwidgJS().Util.String.toUpperCamelCase(attributes[j].name.substring(9));
				attributes[j].value = $('#semwidgckWidgetProperty_input_' + editor.getSemwidgJS().Util.String.toCamelCase(id) + '_' + label).val();
			}
		}
	}
};