CKEDITOR.dialog.add('semwidgTemplateInstanceDialog', function (editor) {

	var dialog = {};

	dialog.title = 'SemwidgJS Template Instance';

	dialog.minWidth = 800;
	dialog.minHeight = 400;

	dialog.contents = [];

	var templateTab = {};
	templateTab.id = 'templateInstanceProperties';
	templateTab.label = 'Template Instance Properties';

	templateTab.elements = [
		{
			type: 'html',
			id: 'templateInstanceTabHtmlInfo',
			html: '<div><h1 id="semwidgckTemplateInstanceTabTitle">Enter Template Instance Properties:</h1></div>'
		},
		{
			type: 'html',
			id: 'templateTabHtmlForm',
			html: '<div id="semwidgckTemplateInstanceTab"></div>',
			setup: function(widget) {
				CKEDITOR.SemwidgJS.SemwidgTemplateInstanceDialog.widget = widget;
				CKEDITOR.SemwidgJS.SemwidgTemplateInstanceDialog.setupTemplateInstanceTab(widget);
			},
			commit: function(widget) {
				CKEDITOR.SemwidgJS.SemwidgTemplateInstanceDialog.commitTemplateInstanceTab(widget);
			}
		}
	];

	dialog.contents.push(templateTab);

	dialog.onShow = function() {
		
		if (CKEDITOR.SemwidgJS.data.templateType) {
			CKEDITOR.SemwidgJS.SemwidgTemplateInstanceDialog.buildTemplateInstanceDialog(this, editor);

			// CKEDITOR.SemwidgJS.setDefaultConfigData(this.configType);
		}
	};

	dialog.onOk = function() {
		this.semwidgClosingType = 'ok';
	};

	dialog.onCancel = function() {
		this.semwidgClosingType = 'cancel';
	};

	dialog.onHide = function() {
		if (this.semwidgClosingType == 'ok') {
			editor.setMode('source');
			editor.setMode('wysiwyg');
		}
	}

	return dialog;
});

CKEDITOR.SemwidgJS.SemwidgTemplateInstanceDialog = function() {

};

CKEDITOR.SemwidgJS.SemwidgTemplateInstanceDialog.buildTemplateInstanceDialog = function(dialog, editor) {

	// build Template Instance Tab
	var templateInstanceTab = $('#semwidgckTemplateInstanceTab');

	var templateInstanceTabHtml = '';
	templateInstanceTabHtml += '<table style="width: 100%;">';
		templateInstanceTabHtml += '<tr>';
			templateInstanceTabHtml += '<td style="padding: 4px 0;">Id:</td>';
			templateInstanceTabHtml += '<td style="padding: 4px 0px 4px 8px; width: 100%;"><input ';
			templateInstanceTabHtml += 'id="semwidgckTemplateInstanceProperty_input0_id" ';
			templateInstanceTabHtml += 'class="cke_dialog_ui_input_text" ';
			templateInstanceTabHtml += '></td>';
		templateInstanceTabHtml += '</tr>';
		templateInstanceTabHtml += '<tr>';
			templateInstanceTabHtml += '<td style="padding: 4px 0;">Template:</td>';
			templateInstanceTabHtml += '<td style="padding: 4px 0px 4px 8px; width: 100%;"><input ';
			templateInstanceTabHtml += 'id="semwidgckTemplateInstanceProperty_input0_template" ';
			templateInstanceTabHtml += 'class="cke_dialog_ui_input_text" ';
			templateInstanceTabHtml += '></td>';
		templateInstanceTabHtml += '</tr>';

		templateInstanceTabHtml += '<tr>';
			templateInstanceTabHtml += '<td style="padding: 22px 0 4px 0;">Parameters</td>';
			templateInstanceTabHtml += '<td style="padding: 4px 0px 4px 8px; width: 100%;">';
				templateInstanceTabHtml += '<hr/>';
			templateInstanceTabHtml += '</td>';
		templateInstanceTabHtml += '</tr>';

		var definition = editor.getSemwidgJS().getTemplateProvider().getTemplateDefinition(
				CKEDITOR.SemwidgJS.data.templateType);

		if (definition) {
			var parameters = definition.getParameters();
			for (var i = 0; i < parameters.length - 1; i++) {
				templateInstanceTabHtml += '<tr class="semwidgckTemplateInstancePropertyRow">';
					templateInstanceTabHtml += '<td style="padding: 4px 0;">' + parameters[i] + ':</td>';
					templateInstanceTabHtml += '<td style="padding: 4px 0px 4px 8px; width: 100%;"><input ';
					templateInstanceTabHtml += 'id="semwidgckTemplateInstanceProperty_input_' + parameters[i] + '" ';
					templateInstanceTabHtml += 'class="cke_dialog_ui_input_text" ';
					templateInstanceTabHtml += '></td>';
				templateInstanceTabHtml += '</tr>';
			}	
		}
	
		templateInstanceTabHtml += '<tr>';
			templateInstanceTabHtml += '<td style="padding: 4px 0;">template:</td>';
			templateInstanceTabHtml += '<td style="padding: 4px 0px 4px 8px; width: 100%;"><input ';
			templateInstanceTabHtml += 'id="semwidgckTemplateInstanceProperty_input_template" ';
			templateInstanceTabHtml += 'class="cke_dialog_ui_input_text" disabled ';
			templateInstanceTabHtml += 'style="background-color: #EEE;"></td>';
		templateInstanceTabHtml += '</tr>';

	templateInstanceTabHtml += '</table>';

	templateInstanceTab.html(templateInstanceTabHtml);

	CKEDITOR.SemwidgJS.SemwidgTemplateInstanceDialog.autocompleteForParameters(parameters, editor);

	$('#semwidgckTemplateInstanceProperty_input0_id').on('keyup', function(e) {
		$('#semwidgckTemplateInstanceProperty_input_template').val(e.target.value);
	});

	$('#semwidgckTemplateInstanceProperty_input0_template').on('blur', function(e) {

		$('#semwidgckTemplateInstanceTab').find('.semwidgckTemplateInstancePropertyRow').remove();

		var templateType = $('#semwidgckTemplateInstanceProperty_input0_template').val();

		var templateInstanceTabHtml = '';
		var definition = editor.getSemwidgJS().getTemplateProvider().getTemplateDefinition(templateType);

		if (definition) {
			var parameters = definition.getParameters();
			for (var i = 0; i < parameters.length - 1; i++) {
				templateInstanceTabHtml += '<tr class="semwidgckTemplateInstancePropertyRow">';
					templateInstanceTabHtml += '<td style="padding: 4px 0;">' + parameters[i] + ':</td>';
					templateInstanceTabHtml += '<td style="padding: 4px 0px 4px 8px; width: 100%;"><input ';
					templateInstanceTabHtml += 'id="semwidgckTemplateInstanceProperty_input_' + parameters[i] + '" ';
					templateInstanceTabHtml += 'class="cke_dialog_ui_input_text" ';
					templateInstanceTabHtml += '></td>';
				templateInstanceTabHtml += '</tr>';
			}

			$('#semwidgckTemplateInstanceTab').find('tr').eq(2).after(templateInstanceTabHtml);
			var widget = CKEDITOR.SemwidgJS.SemwidgTemplateInstanceDialog.widget;
			var value;
			for (var i = 0; i < parameters.length - 1; i++) {
				value = widget.element.getAttribute('data-swp-' + parameters[i]);
				$('#semwidgckTemplateInstanceProperty_input_' + parameters[i]).val(value);
			}

			CKEDITOR.SemwidgJS.SemwidgTemplateInstanceDialog.autocompleteForParameters(parameters, editor);
		}

	});

	var templateAutosuggest = CKEDITOR.SemwidgJS.textInputToAutosuggest('semwidgckTemplateInstanceProperty_input0_template', false);

	templateAutosuggest.setSelectFunction(function(value) {
		this.element.val(value);
		this.element.focus();
	});

	templateAutosuggest.setRequestFunction(function(value) {

		var templateDefinitions = editor.getSemwidgJS().getTemplateProvider().getTemplateDefinitions();
		var resultContains = [];
		var resultContainsNot = [];

		if (templateDefinitions) {
			for (var i = 0; i < templateDefinitions.length; i++) {
				if (templateDefinitions[i].getId().indexOf(value) > -1) {
					resultContains.push(templateDefinitions[i].getId());
				}else {
					resultContainsNot.push(templateDefinitions[i].getId());
				}
			}
		};

		var simpleStringArraySort = function(a, b) {
			var levA = CKEDITOR.SemwidgJS.levenshteinDistance(a, value);
			var levB = CKEDITOR.SemwidgJS.levenshteinDistance(b, value);

			return levA - levB;
		};

		resultContains.sort(simpleStringArraySort);
		resultContainsNot.sort(simpleStringArraySort);

		var result = resultContains.concat(resultContainsNot);

		for (var i = 0; i < result.length; i++) {
			result[i] = ['<span style="font-family: monospace;">' + result[i] + '</span>', result[i]];
		}

		this.setResult(result);
		
	}, 0);

};

CKEDITOR.SemwidgJS.SemwidgTemplateInstanceDialog.setupTemplateInstanceTab = function(widget) {

	var id = widget.element.getAttribute('data-swp-id');
	if (id){
		$('#semwidgckTemplateInstanceProperty_input0_id').val(id);
		$('#semwidgckTemplateInstanceProperty_input_template').val(id);
	}

	var template = CKEDITOR.SemwidgJS.data.templateType;
	$('#semwidgckTemplateInstanceProperty_input0_template').val(template);

	var definition = widget.editor.getSemwidgJS().getTemplateProvider().getTemplateDefinition(template);

	if (definition) {

		var parameters = definition.getParameters();

		var value;
		for (var i = 0; i < parameters.length - 1; i++) {
			value = widget.element.getAttribute('data-swp-' + parameters[i]);
			$('#semwidgckTemplateInstanceProperty_input_' + parameters[i]).val(value);
		}
	}
};

CKEDITOR.SemwidgJS.SemwidgTemplateInstanceDialog.commitTemplateInstanceTab = function(widget) {

	var editor = widget.editor;

	// add Id if not set
	if (editor.getSemwidgJS().Util.String.isEmpty($('#semwidgckTemplateInstanceProperty_input0_id').val())) {
		$('#semwidgckTemplateInstanceProperty_input0_id').val('TemplateInstance-' + editor.getSemwidgJS().Util.getUniqueId());
	}

	widget.element.setAttribute('data-swp-id', $('#semwidgckTemplateInstanceProperty_input0_id').val());

	widget.element.setAttribute('data-sw-template', $('#semwidgckTemplateInstanceProperty_input0_template').val());

	var definition = editor.getSemwidgJS().getTemplateProvider().getTemplateDefinition(
			$('#semwidgckTemplateInstanceProperty_input0_template').val());

	if (definition) {
		var parameters = definition.getParameters();

		var value;
		for (var i = 0; i < parameters.length - 1; i++) {
			value = $('#semwidgckTemplateInstanceProperty_input_' + parameters[i]).val()
			widget.element.setAttribute('data-swp-' + parameters[i], value);
		}
	}

	CKEDITOR.SemwidgJS.newElementIds.push($('#semwidgckTemplateInstanceProperty_input0_id').val());

};

CKEDITOR.SemwidgJS.SemwidgTemplateInstanceDialog.autocompleteForParameters = function(parameters, editor) {
	for (var i = 0; i < parameters.length - 1; i++) {
		var id = 'semwidgckTemplateInstanceProperty_input_' + parameters[i];
		autosuggest = CKEDITOR.SemwidgJS.textInputToAutosuggest(id, true);
		autosuggest.setRequestFunction(CKEDITOR.SemwidgJS.SemwidgTemplateInstanceDialog.requestFunction(autosuggest, editor));
		autosuggest.setSelectFunction(CKEDITOR.SemwidgJS.SemwidgTemplateInstanceDialog.selectFunction(autosuggest, editor));
	}
};

CKEDITOR.SemwidgJS.SemwidgTemplateInstanceDialog.requestFunction = function(autosuggest, editor) {
	return function(value) {
		var resources = editor.getSemwidgJS().getConfig().getResources();
		var resultContains = [];
		var resultContainsNot = [];

		if (resources) {
			for (var i = 0; i < resources.length; i++) {
				if (resources[i].getId().indexOf(value) > -1) {
					resultContains.push(resources[i].getId());
				}else {
					resultContainsNot.push(resources[i].getId());
				}
			}
		};

		var simpleStringArraySort = function(a, b) {
			var levA = CKEDITOR.SemwidgJS.levenshteinDistance(a, value);
			var levB = CKEDITOR.SemwidgJS.levenshteinDistance(b, value);

			return levA - levB;
		};

		resultContains.sort(simpleStringArraySort);
		resultContainsNot.sort(simpleStringArraySort);

		var result = resultContains.concat(resultContainsNot);

		for (var i = 0; i < result.length; i++) {
			result[i] = ['<span style="font-family: monospace;">' + result[i] + '</span>', result[i]];
		}

		autosuggest.setResult(result);
	};
};

CKEDITOR.SemwidgJS.SemwidgTemplateInstanceDialog.selectFunction = function(autosuggest, editor) {

	return function(value) {
		if (value && value != '') {
			autosuggest.element.val(value);
		}
	};
};
